///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains the base class.
 *	\file		IceCell.h
 *	\author		Pierre Terdiman
 *	\date		February, 5, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICECELL_H__
#define __ICECELL_H__

	//! Cell flags
	#define CF_VALID		(1<<0)		//!< Cell has successfully been initialized

	class Kernel;
//	class DataBlock;

	class ICECORE_API Cell
	{
	protected:
		// Constructor/Destructor
		//! TO BE DOCUMENTED
										Cell();
		//! TO BE DOCUMENTED
			virtual						~Cell();
	public:
		//! TO BE DOCUMENTED
			virtual	udword				Import(ImportContext& ic);
		//! TO BE DOCUMENTED
			virtual	udword				Export(ExportContext& ec);
		//! TO BE DOCUMENTED
			virtual	bool				GetEditableFields(Container& edit);

		//! TO BE DOCUMENTED
					bool				CreateRef(Cell* ref);
		//! TO BE DOCUMENTED
					bool				DeleteRef(Cell* ref);

		//! TO BE DOCUMENTED
					udword				GetNbRefs();
		//! TO BE DOCUMENTED
					udword				GetNbOwners();

		//! TO BE DOCUMENTED
					Cell*				GetOwner(udword i=0);
		//! TO BE DOCUMENTED
					Cell*				GetRef(udword i=0);

		//! TO BE DOCUMENTED
					uword				GetID()						{ return m__ID;		}

		//! TO BE DOCUMENTED
//					DataBlock*			CreateDataBlock(udword length);

		//! TO BE DOCUMENTED
					CLASS_DESCRIPTOR;
	private:
					uword				m__ID;
					uword				m__Flags;
					udword				m__Type;

			friend	class				Kernel;
	};
/*
	class ICECORE_API DataBlock : public Cell
	{
	public:
		// Constructor/Destructor
										DataBlock();
			virtual						~DataBlock();

			DECLARE_IMPORT_EXPORT(DataBlock, Cell);

					DataBlock*			Dup();
		// Initialize
					bool				Init(udword length);
		// Data access
					udword				GetLength()					{ return mLength;	}
					ubyte*				GetData()					{ return mData;		}

	private:
					udword				mLength;
					ubyte*				mData;
	};
*/

#endif // __ICECELL_H__
