///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains a simple container class.
 *	\file		IceContainer.h
 *	\author		Pierre Terdiman
 *	\date		February, 5, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICECONTAINER_H__
#define __ICECONTAINER_H__

	class ICECORE_API Container
	{
	public:
			// Constructor/Destructor
			Container();
			~Container();

			// Management
			Container&		Add(udword entry);
			Container&		Add(float entry);
			Container&		Empty();
			Container&		Reset();
			bool			Contains(udword entry);
			bool			Delete(udword entry);

			// Stats
			udword			GetUsedRam();

			// Data access.
			udword			GetNbEntries()			{ return mCurNbEntries;	}	//!< Returns the current number of entries.
			udword*			GetEntries()			{ return mEntries;		}	//!< Returns the list of entries.

	private:
			udword			mMaxNbEntries;
			udword			mCurNbEntries;
			udword*			mEntries;
	};

#endif // __ICECONTAINER_H__
