///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	This file contains the texture-related exported structures.
 *	\file		IceAddTexture.h
 *	\author		Pierre Terdiman
 *	\date		April, 4, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICEADDTEXTURE_H__
#define __ICEADDTEXTURE_H__

	//! A possible texture matrix.
	struct TextureMatrix
	{
		//! Warning: that's a direct dump from MAX (untransformed)
		float m[4][3];
	};

	//! Crop values. Useful for T-pages. Warning: equations to use them are weird.
	struct TextureCrop
	{
		float	OffsetU;	//!< Offset for U
		float	OffsetV;	//!< Offset for V
		float	ScaleU;		//!< Scale for U
		float	ScaleV;		//!< Scale for V
	};

	//! The texture information class.
	class TextureInfo : public ObjectInfo
	{
	public:
								TextureInfo();
		virtual					~TextureInfo();

				TextureCrop		mCValues;						//!< Cropping values
				TextureMatrix	mTMtx;							//!< Texture matrix

				// Following fields are only valid if TexnameOnly is false in the ExportSettings structure.
				udword			mWidth;							//!< Texture's width
				udword			mHeight;						//!< Texture's height
				ubyte*			mPixels;						//!< Texture in R,G,B,A order. (always contains Alpha)
				bool			mHasAlpha;						//!< True => Alpha is valid.
	};

#endif // __ICEADDTEXTURE_H__
