///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	This file contains the ZCB Format exporter plug-in for Flexporter.
 *	\file		IceZCBExporter.h
 *	\author		Pierre Terdiman
 *	\date		April, 4, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICEZCBEXPORTER_H__
#define __ICEZCBEXPORTER_H__

	class ZCBFormat : public ExportFormat
	{
	public:
	// Constructor/Destructor
										ZCBFormat();
		virtual							~ZCBFormat();

	// Exporter init
		virtual	bool					Init(bool motion);

	// Main scene info
		virtual bool					SetSceneInfo(MainInfo& maininfo);

	// Export loop
				bool					ExportBasicInfo		(ObjectInfo* obj, CustomArray* array);

		virtual bool					ExportCamera		(CameraInfo& camera);
		virtual bool					ExportController	(ControllerInfo& controller);
		virtual bool					ExportHelper		(HelperInfo& helper);
		virtual bool					ExportLight			(LightInfo& light);
		virtual bool					ExportMaterial		(MaterialInfo& material);
		virtual bool					ExportMesh			(MeshInfo& mesh);
		virtual bool					ExportMotion		(MotionInfo& motion);
		virtual bool					ExportShape			(ShapeInfo& shape);
		virtual bool					ExportTexture		(TextureInfo& texture);

	// End of export notification
		virtual bool					EndExport(StatsInfo& stats);

	private:
	// Time info local copy
				TimeInfo				mTimeInfo;
	// Export arrays
				CustomArray				mGeneral;
				CustomArray				mGeomObjects;
				CustomArray				mCameras;
				CustomArray				mLights;
				CustomArray				mShapes;
				CustomArray				mHelpers;
				CustomArray				mTexmaps;
				CustomArray				mMaterials;
				CustomArray				mControllers;
				CustomArray				mMotion;
	// Flags
				bool					mIsMotionFile;
	};

#endif // __ICEZCBEXPORTER_H__
