///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	This file contains all ZCB format-related constants.
 *	\file		IceZCBFormat.h
 *	\author		Pierre Terdiman
 *	\date		April, 4, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICEZCBFORMAT_H__
#define __ICEZCBFORMAT_H__

	// Chunk versions
	#define	CHUNK_MAIN_VER			1
	#define	CHUNK_MESH_VER			2
	#define	CHUNK_CAMS_VER			1
	#define	CHUNK_LITE_VER			1
	#define	CHUNK_SHAP_VER			1
	#define	CHUNK_HELP_VER			1
	#define	CHUNK_TEXM_VER			1
	#define	CHUNK_MATL_VER			1
	#define	CHUNK_CTRL_VER			1
	#define	CHUNK_MOVE_VER			1

	// Mesh flags.
	#define	ZCB_VFACE				(1<<0)				//!< Mesh has vertex-faces.
	#define	ZCB_TFACE				(1<<1)				//!< Mesh has texture-faces.
	#define	ZCB_CFACE				(1<<2)				//!< Mesh has color-faces.
	#define ZCB_UVW					(1<<3)				//!< UVW's are exported
	#define ZCB_WDISCARDED			(1<<4)				//!< W is discarded
	#define ZCB_VERTEXCOLORS		(1<<5)				//!< Vertex colors are exported
	#define	ZCB_ONEBONEPERVERTEX	(1<<6)				//!< Simple skin with one driving bone/vertex
	#define	ZCB_CONVEXHULL			(1<<7)				//!< The convex hull has been exported
	#define	ZCB_BOUNDINGSPHERE		(1<<8)				//!< The bounding sphere has been exported
	#define	ZCB_INERTIATENSOR		(1<<9)				//!< The inertia tensor has been exported

	#define	ZCB_CONSOLIDATION		(1<<16)				//!< Mesh has been consolidated
	#define	ZCB_FACENORMALS			(1<<17)				//!< Export normals to faces
	#define	ZCB_VERTEXNORMALS		(1<<18)				//!< Export normals to vertices
	#define	ZCB_NORMALINFO			(1<<19)				//!< Export NormalInfo

	// Scene flags
	#define	ZCB_FILE_SCENE			0x00001000			//!< Complete 3D scene
	#define	ZCB_FILE_MOTION			0x00001100			//!< Motion file

	// Controllers flags
	#define	ZCB_CTRL_NONE			0					//!< No controller
	#define	ZCB_CTRL_FLOAT			1					//!< Float controller
	#define	ZCB_CTRL_VECTOR			2					//!< Vector controller
	#define	ZCB_CTRL_QUAT			3					//!< Quaternion controller
	#define	ZCB_CTRL_PR				4					//!< PR controller
	#define	ZCB_CTRL_PRS			5					//!< PRS controller

	#define	ZCB_CTRL_SAMPLES		1					//!< Samples
	#define	ZCB_CTRL_KEYFRAMES		2					//!< Keyframes

#endif // __ICEZCBFORMAT_H__
