///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	This file contains the Void Format exporter plug-in for Flexporter.
 *	\file		VoidExporter.h
 *	\author		Pierre Terdiman
 *	\date		May, 6, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __VOIDEXPORTER_H__
#define __VOIDEXPORTER_H__

	class VoidFormat : public ExportFormat
	{
	public:
	// Constructor/Destructor
										VoidFormat();
		virtual							~VoidFormat();

	// Exporter init
		virtual	bool					Init(bool motion);

	// Main scene info
		virtual bool					SetSceneInfo(MainInfo& maininfo);

	// Export loop
		virtual bool					ExportCamera		(CameraInfo& camera);
		virtual bool					ExportController	(ControllerInfo& controller);
		virtual bool					ExportHelper		(HelperInfo& helper);
		virtual bool					ExportLight			(LightInfo& light);
		virtual bool					ExportMaterial		(MaterialInfo& material);
		virtual bool					ExportMesh			(MeshInfo& mesh);
		virtual bool					ExportMotion		(MotionInfo& motion);
		virtual bool					ExportShape			(ShapeInfo& shape);
		virtual bool					ExportTexture		(TextureInfo& texture);

	// End of export notification
		virtual bool					EndExport(StatsInfo& stats);

	private:
	};

#endif // __VOIDEXPORTER_H__
